package com.sf.javase.day07.homework;

public class Triangle {
    /**
     * 声明一个三角形类Triangle，包含属性：a,b,c，都是double类型，表示三条边，包含几个方法：
     * boolean isTriangle()：判断是否是一个三角形
     * boolean isRightTriangle()：判断是否是一个直角三角形
     * boolean isIsoscelesTriangle()：判断是否是一个等腰三角形
     * boolean isEquilateralTriangle()：判断是否是一个等边三角形
     * double area()：根据三条边，用海伦公式求面积
     * double perimeter()：求周长
     */

    double a;
    double b;
    double c;

    /**
     *  boolean isTriangle()：判断是否是一个三角形
     */
    public boolean  isTriangle(){
        return a>0&&b>0&&c>0&&a+b>c&&a+c>b&&b+c>a;
    }

    /**
     * boolean isRightTriangle()：判断是否是一个直角三角形
     */
    public boolean isRightTriangle(){
        return isTriangle()&&(a*a+b*b==c*c  || a*a+c*c==b*b  ||a*a==b*b+c*c);
    }

    /**
     * boolean isIsoscelesTriangle()：判断是否是一个等腰三角形
     */

    public boolean isIsoscelesTriangle(){
        return isTriangle()&&(a==b ||b==c ||a==c);
    }

    /**
     * 等边三角形
     * @return
     */
    public boolean isEquilateralTriangle(){
        return isTriangle()&&(a==b && b==c && a==c);
    }

    /**
     * double perimeter()：求周长
     */
    public double perimeter(){
        if(isTriangle()){
            return a+b+c;
        }else return 0.0;
    }

    /**
     * double area()：根据三条边，用海伦公式求面积
     */
    public double area(){
        if(isTriangle()){
            double perimeter = (a+b+c)/2;
            return Math.sqrt(perimeter*(perimeter-a)*(perimeter-b)*(perimeter-c));//求平方根
        }else return 0.0;
    }
}
